//----------------------------------------------------------------------------------
// aviutlvOC C^Ȓጸ(LPF)
//
//----------------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <malloc.h>
#include <process.h>

#include "filter.h"
#include "lpf_v.h"
#include "mov.h"

//---------------------------------------------------------------------
// ֐
//---------------------------------------------------------------------
static BOOL isSSEusable(void);
unsigned __stdcall thProc(void *);
short *get_motion(FILTER *fp, FILTER_PROC_INFO *fpip, int n);

typedef struct tag_thData
{
  FILTER *fp;
  FILTER_PROC_INFO *fpip;
  int fnum;
} thData;

//---------------------------------------------------------------------
// O[oϐ
//---------------------------------------------------------------------
// tB^֐
int (*lpf_v[])(PIXEL_YC*, PIXEL_YC*, int, int, int, int, int)
 = { lpf_v_3,     lpf_v_5,     lpf_v_7,     lpf_v_9,
     lpf_v_11,    lpf_v_13,     lpf_v_15,
     lpf_v_3_mmx, lpf_v_5_mmx, lpf_v_7_mmx, lpf_v_9_mmx,
     lpf_v_11_mmx,lpf_v_13_mmx, lpf_v_15_mmx };

// I֐
short *(*select_mov[])(short*, short*, int, int, int)
     = { select_min, select_max, select_min_sse, select_max_sse };

// o֐
void (*detect_mov[])(PIXEL_YC*, PIXEL_YC*, short*, int, int, int, int)
     = { detect_motion, detect_motion_sse };

// uh֐
void (*brend_img[])(PIXEL_YC*, PIXEL_YC*, short*, int, int ,int)
     = { brend_image, brend_image_mmx };

// }XN
short *g_tmp0 = NULL;
short *g_tmp1 = NULL;
int g_tmp0_n = -1;
int g_tmp1_n = -1;

// SSELǂ
int g_sse = 0;

// [J[Xbh̃nh
HANDLE g_thr = 0;

// NeBJZNV
CRITICAL_SECTION g_cs;

// Xbhւ̎w
enum COMMAND { STOP, START, EXIT };
enum COMMAND g_com = STOP;
thData g_thd;

//LARGE_INTEGER g_st,g_ed;

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 4
TCHAR *track_name[] = {"tap", "", "", "" };
int   track_default[] = { 0, 0, 0, 24 };
int   track_s[] = { 0, 0 , 0, 0 };
int   track_e[] = { 6, 64, 64, 256 };
enum  { T_TAP, T_TOP, T_BTM, T_MTH };

#define CHECK_N 5
TCHAR *check_name[]
 = { "MMX/SSE", "̕\", "t[QƂ", "MAX", "}`Xbh" };
int    check_default[] = { 1, 0, 0, 0, 0 };
enum { C_MMX, C_DISP, C_BOTH, C_MAX, C_THR };

FILTER_DLL filter = {
  FILTER_FLAG_EX_INFORMATION, 0,0,
  "C^ȒጸA",  //tB^̖O
  TRACK_N, track_name, track_default, track_s, track_e,
  CHECK_N, check_name, check_default,
  func_proc,   //tB^֐ւ̃|C^ (NULLȂĂ΂܂)
  func_init,   //JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  func_exit,   //IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  func_update, //ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,        //ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,NULL,   //VXeŎg܂̂ŎgpȂł
  NULL,        //  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
  0,           //  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
  "lpf_decomb by N099, ver1.3",
  NULL, NULL,
};

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
  return &filter;
}

//---------------------------------------------------------------------
// ɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
  SYS_INFO si;
  size_t sz;
  unsigned threadID;
  
  if(!fp->exfunc->get_sys_info(NULL, &si))
    return FALSE;

  //Ɨpp si.vram_w, si.vram_h 𗘗p "2"͂܂
  sz = si.vram_w * (si.vram_h + 2) * 2 * sizeof(short);
  g_tmp0 = _aligned_malloc(sz, 16);
  if(NULL == g_tmp0){
    return FALSE;
  }
  
  g_tmp1 = _aligned_malloc(sz, 16);
  if(NULL == g_tmp1){
    _aligned_free(g_tmp0);
    g_tmp0 = NULL;
    return FALSE;
  }

  //SSẼ`FbN
  g_sse =isSSEusable();

  //[J[Xbh̋N
  InitializeCriticalSection(&g_cs);
  EnterCriticalSection(&g_cs);
  g_thr = (HANDLE)_beginthreadex(NULL, 0, thProc, NULL, 0, &threadID);
  ZeroMemory(&g_thd, sizeof(g_thd));
  
  return TRUE;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit( FILTER *fp )
{
  if(NULL != g_tmp0){
    _aligned_free(g_tmp0);
    g_tmp0 = NULL;
  }

  if(NULL != g_tmp1){
    _aligned_free(g_tmp1);
    g_tmp1 = NULL;
  }

  if(g_thr){
    //Xbh̒~
    EnterCriticalSection(&g_cs);
    LeaveCriticalSection(&g_cs);
    g_com = EXIT;
    LeaveCriticalSection(&g_cs);
    WaitForSingleObject(g_thr, INFINITE);
    CloseHandle(g_thr);
    g_thr = 0;
  }
  DeleteCriticalSection(&g_cs);

  return TRUE;
}

//---------------------------------------------------------------------
// ݒύXɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_update(FILTER *fp, int status)
{
  if(status == FILTER_UPDATE_STATUS_TRACK + T_MTH){
  }else if(status == FILTER_UPDATE_STATUS_CHECK + C_MMX){
  }else if(status == FILTER_UPDATE_STATUS_ALL){
  }else{
    return TRUE;
  }

  g_tmp0_n = g_tmp1_n = -1;
  
  return TRUE;
}

//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
  int fn_lpf, fn_bre;
  PIXEL_YC *ycp;
  short *pm;

  //QueryPerformanceCounter(&g_st);

  if(!fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->max_w, fpip->h, 3, 0))
    return FALSE;

  //tB^̑I
  fn_lpf  = fp->track[T_TAP];
  fn_lpf += fp->check[C_MMX] * (track_e[T_TAP] + 1);
  fn_bre  = fp->check[C_MMX];
  
  if(fp->check[C_THR] && fp->track[T_MTH] > 0){
    //}`Xbh and o
    g_com = START;
    g_thd.fp = fp;
    g_thd.fpip = fpip;
    g_thd.fnum = fn_lpf;
    LeaveCriticalSection(&g_cs);

    //ʃXbhLPF̏sĂ
    //{̓Cxg𗘗pđ҂ׂH
    //Sleep(0);

    //o
    pm = get_motion(fp, fpip, fp->check[C_BOTH]);
    
    EnterCriticalSection(&g_cs);
    
    brend_img[fn_bre](fpip->ycp_temp, fpip->ycp_edit, pm, fpip->h, fpip->max_w, fpip->w);
    if(fp->check[C_DISP]){
      disp_motion(fpip->ycp_temp, pm, fpip->h, fpip->max_w, fpip->w);
    }
  }else{ //VOXbh or oȂ
    //LPF
    lpf_v[fn_lpf]( fpip->ycp_temp, fpip->ycp_edit,
                   fpip->h,
                   fp->track[T_TOP], fp->track[T_BTM],
                   fpip->max_w, fpip->w );
    
    //o
    if(fp->track[T_MTH] > 0){
      pm = get_motion(fp, fpip, fp->check[C_BOTH]);
      brend_img[fn_bre](fpip->ycp_temp, fpip->ycp_edit, pm, fpip->h, fpip->max_w, fpip->w);
      if(fp->check[C_DISP]){
        disp_motion(fpip->ycp_temp, pm, fpip->h, fpip->max_w, fpip->w);
      }
    }
  }

  ycp = fpip->ycp_temp;
  fpip->ycp_temp = fpip->ycp_edit;
  fpip->ycp_edit = ycp;

  /*
  QueryPerformanceCounter(&g_ed);

  if(!fp->exfunc->is_saving(fpip->editp)){
    TCHAR buf[256];
    double d = g_ed.QuadPart - g_st.QuadPart;
    sprintf(buf, "%s CLK:%e", filter.name, d);
    SetWindowText(fp->hwnd, buf);
  }
  */
  
  return TRUE;
}

//---------------------------------------------------------------------
// SSEɑΉĂ邩`FbN
//---------------------------------------------------------------------
static int isSSEusable(void)
{
  long r_ecx,r_edx;

  // CPUIDɂ`FbN
  __asm {
    mov eax, 1 ;
    cpuid ;
    mov r_edx, edx;
    mov r_ecx, ecx;
  }

  // MMX  0x0800000 edx
  // SSE  0x2000000 edx
  // SSE2 0x4000000 edx
  // SSE3 0x0000001 ecx
  r_edx &= 0x6800000;
  r_ecx &= 0x0000001;

  if(r_edx < 0x1000000)
    return 0;

  // OST|[gĂ邩
  __try {
    __asm xorps xmm0, xmm0;
  }
  
  __except(EXCEPTION_EXECUTE_HANDLER){
    if (_exception_code()==STATUS_ILLEGAL_INSTRUCTION)
      /* SSE not supported */
      return 0;
  }
  /* SSE are supported by OS */
  return 1;
}

//---------------------------------------------------------------------
// Xbh
//---------------------------------------------------------------------
unsigned __stdcall thProc(void * p)
{
  int loop = 1;
  while(loop){
    EnterCriticalSection(&g_cs);
    switch(g_com){
    case EXIT:
      loop = 0;
      break;
    case START:
      lpf_v[g_thd.fnum](g_thd.fpip->ycp_temp, g_thd.fpip->ycp_edit,
                        g_thd.fpip->h,
                        g_thd.fp->track[T_TOP], g_thd.fp->track[T_BTM],
                        g_thd.fpip->max_w, g_thd.fpip->w );
      g_com = STOP;
      break;
    case STOP:
    default:
      Sleep(0);
      break;
    }
    
    LeaveCriticalSection(&g_cs);
  }

  _endthreadex(0);
  return 0;
}

//---------------------------------------------------------------------
// }XNւ̃|C^Ԃ
// n == 0 őÕt[Ƃ̔r n != 0 őOt[Ƃ̔r
//---------------------------------------------------------------------
short *get_motion(FILTER *fp, FILTER_PROC_INFO *fpip, int n)
{
  PIXEL_YC *ycp;
  short *ret;
  const int fn_sel = fp->check[C_MAX] + 2*(g_sse & fp->check[C_MMX]);
  const int fn_det = g_sse & fp->check[C_MMX];

  // g_tmp0 ɂ͋t[
  // g_tmp1 ɂ͊t[
  // ƂOt[Ɠ}XNLbVĂ
  if(g_tmp0_n == fpip->frame){
    ret = g_tmp0;
  }else if(g_tmp1_n == fpip->frame){
    ret = g_tmp1;
  }else{
    //LbVĂȂ
    if(fpip->frame&1){
      ret = g_tmp1;
      g_tmp1_n = fpip->frame;
    }else{
      ret = g_tmp0;
      g_tmp0_n = fpip->frame;
    }
    //fpip->ycp_editɌ݂̃t[Ă
    ycp = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp,
                                                 fpip->frame-1, NULL, NULL);
    detect_mov[fn_det](ycp, fpip->ycp_edit, ret,
                       fpip->h, fpip->max_w, fpip->w, fp->track[T_MTH]);
  }
  
  //Ot[Ƃ̔r
  if(n){
    short *sp;
    if(g_tmp0_n == fpip->frame+1){
      sp = g_tmp0;
    }else if(g_tmp1_n == fpip->frame+1){
      sp = g_tmp1;
    }else{
      //LbVĂȂ
      if(fpip->frame&1){
        sp = g_tmp0;
        g_tmp0_n = fpip->frame + 1;
      }else{
        sp = g_tmp1;
        g_tmp1_n = fpip->frame + 1;
      }
      ycp = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp,
                                                   fpip->frame+1, NULL, NULL);
      detect_mov[fn_det](ycp, fpip->ycp_edit, sp,
                         fpip->h, fpip->max_w, fpip->w, fp->track[T_MTH]);
    }
    //I֐
    ret = select_mov[fn_sel](ret, sp, fpip->h, fpip->max_w, fpip->w);
  }

  return ret;
}

